// ChkNEvnt.prg which modifies the
//	chkevent.prg - check/handle events
//
//	Written by:	John M. Skelton, 27-Aug-92.
// Modified by J-P. Zacaropoulos for use with Padding.Exe
//
//	Copyright (C) 1992 Skelton Software, Kendal Cottage, Hillam, Leeds LS25 5HP, UK.
//	All Rights Reserved.
//
// Deleted the CASE of EVENT_ACCELKEY
// Deleted event() since it is already in C4W LIB version 1.2

#include "windows.ch"

external errorsys		// remove this if you don't want it!

*  Function Ŀ
*          Name: ChkNEvnt()            Docs: Wine Software Partners         
*   Description: Modified version of ChkEvent() supplied w/C4W              
*  Date created: 02-11-94              Date updated: 02-11-94              
*  Time created: 03:17:31pm            Time updated: 03:17:31pm            
* Ĵ
*     Arguments: None                                                       
*  Return Value: ev -------> the nEvent Number                              
*      See Also:                                                            
* 
function ChkNEvnt()
local	ev, hWnd, hMenu, nId
do while .t.
	ev = _ChkEvent()
	if ev == EVENT_NONE
		exit
	endif

	// can do mapping in here

	if ev == EVENT_MENU
		// handle menu selection immediately
		SelectWindow(hWnd := _LasthWnd())
		ExecuteMenu(hWnd, _LastwParam())
	else
		exit
	endif
enddo

//
//  At this point, _LastMsg(), _LastwParam() and _LastlParam(), together
//  with the other functions mentioned, have other useful information,
//  as follows:
//
// event type:			other info:
//
//	EVENT_KEY		inkey()		the keystroke
//
//	EVENT_LCLICK		MouseX(), MouseY()	the x,y position
//				MouseRow(), MouseCol()	the row,col position
//	EVENT_LDBLCLK \
//	EVENT_RCLICK   \
//	EVENT_RDBLCLK   >---	see EVENT_LCLICK
//	EVENT_MCLICK   /
//	EVENT_MDBLCLK /
//
//	EVENT_REDRAW		none; just re-draw the client area
//
//	EVENT_SETFOCUS		none; window is being given input focus
//
//	EVENT_KILLFOCUS		none; window is losing input focus
//
//	EVENT_WINMOVE		_LastLolParam() is the x position
//				_LastHilParam() is the y position
//
//	EVENT_WINSIZE		_LastLolParam() is the new width in pixels
//				_LastHilParam() is the new height in pixels
//
//	EVENT_CONTROL		_LastwParam()	the control's id
//
//	EVENT_HSCROLL		_LastwParam()	the scrollbar code
//						(one of the SB_* values)
//
//	EVENT_VSCROLL		_LastwParam()	the scrollbar code
//						(one of the SB_* values)

return ev


// --------End of ChkNEvent.Prg
